t / test-lib.shon commit test-lib: silence "-x" cleanup under bash (90c8a1d)
   1# Test framework for git.  See t/README for usage.
   2#
   3# Copyright (c) 2005 Junio C Hamano
   4#
   5# This program is free software: you can redistribute it and/or modify
   6# it under the terms of the GNU General Public License as published by
   7# the Free Software Foundation, either version 2 of the License, or
   8# (at your option) any later version.
   9#
  10# This program is distributed in the hope that it will be useful,
  11# but WITHOUT ANY WARRANTY; without even the implied warranty of
  12# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  13# GNU General Public License for more details.
  14#
  15# You should have received a copy of the GNU General Public License
  16# along with this program.  If not, see http://www.gnu.org/licenses/ .
  17
  18# Test the binaries we have just built.  The tests are kept in
  19# t/ subdirectory and are run in 'trash directory' subdirectory.
  20if test -z "$TEST_DIRECTORY"
  21then
  22        # We allow tests to override this, in case they want to run tests
  23        # outside of t/, e.g. for running tests on the test library
  24        # itself.
  25        TEST_DIRECTORY=$(pwd)
  26else
  27        # ensure that TEST_DIRECTORY is an absolute path so that it
  28        # is valid even if the current working directory is changed
  29        TEST_DIRECTORY=$(cd "$TEST_DIRECTORY" && pwd) || exit 1
  30fi
  31if test -z "$TEST_OUTPUT_DIRECTORY"
  32then
  33        # Similarly, override this to store the test-results subdir
  34        # elsewhere
  35        TEST_OUTPUT_DIRECTORY=$TEST_DIRECTORY
  36fi
  37GIT_BUILD_DIR="$TEST_DIRECTORY"/..
  38
  39# If we were built with ASAN, it may complain about leaks
  40# of program-lifetime variables. Disable it by default to lower
  41# the noise level. This needs to happen at the start of the script,
  42# before we even do our "did we build git yet" check (since we don't
  43# want that one to complain to stderr).
  44: ${ASAN_OPTIONS=detect_leaks=0:abort_on_error=1}
  45export ASAN_OPTIONS
  46
  47# If LSAN is in effect we _do_ want leak checking, but we still
  48# want to abort so that we notice the problems.
  49: ${LSAN_OPTIONS=abort_on_error=1}
  50export LSAN_OPTIONS
  51
  52################################################################
  53# It appears that people try to run tests without building...
  54"$GIT_BUILD_DIR/git" >/dev/null
  55if test $? != 1
  56then
  57        echo >&2 'error: you do not seem to have built git yet.'
  58        exit 1
  59fi
  60
  61. "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
  62export PERL_PATH SHELL_PATH
  63
  64# if --tee was passed, write the output not only to the terminal, but
  65# additionally to the file test-results/$BASENAME.out, too.
  66case "$GIT_TEST_TEE_STARTED, $* " in
  67done,*)
  68        # do not redirect again
  69        ;;
  70*' --tee '*|*' --va'*|*' --verbose-log '*)
  71        mkdir -p "$TEST_OUTPUT_DIRECTORY/test-results"
  72        BASE="$TEST_OUTPUT_DIRECTORY/test-results/$(basename "$0" .sh)"
  73
  74        # Make this filename available to the sub-process in case it is using
  75        # --verbose-log.
  76        GIT_TEST_TEE_OUTPUT_FILE=$BASE.out
  77        export GIT_TEST_TEE_OUTPUT_FILE
  78
  79        # Truncate before calling "tee -a" to get rid of the results
  80        # from any previous runs.
  81        >"$GIT_TEST_TEE_OUTPUT_FILE"
  82
  83        (GIT_TEST_TEE_STARTED=done ${SHELL_PATH} "$0" "$@" 2>&1;
  84         echo $? >"$BASE.exit") | tee -a "$GIT_TEST_TEE_OUTPUT_FILE"
  85        test "$(cat "$BASE.exit")" = 0
  86        exit
  87        ;;
  88esac
  89
  90# For repeatability, reset the environment to known value.
  91# TERM is sanitized below, after saving color control sequences.
  92LANG=C
  93LC_ALL=C
  94PAGER=cat
  95TZ=UTC
  96export LANG LC_ALL PAGER TZ
  97EDITOR=:
  98# A call to "unset" with no arguments causes at least Solaris 10
  99# /usr/xpg4/bin/sh and /bin/ksh to bail out.  So keep the unsets
 100# deriving from the command substitution clustered with the other
 101# ones.
 102unset VISUAL EMAIL LANGUAGE COLUMNS $("$PERL_PATH" -e '
 103        my @env = keys %ENV;
 104        my $ok = join("|", qw(
 105                TRACE
 106                DEBUG
 107                TEST
 108                .*_TEST
 109                PROVE
 110                VALGRIND
 111                UNZIP
 112                PERF_
 113                CURL_VERBOSE
 114                TRACE_CURL
 115        ));
 116        my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
 117        print join("\n", @vars);
 118')
 119unset XDG_CONFIG_HOME
 120unset GITPERLLIB
 121GIT_AUTHOR_EMAIL=author@example.com
 122GIT_AUTHOR_NAME='A U Thor'
 123GIT_COMMITTER_EMAIL=committer@example.com
 124GIT_COMMITTER_NAME='C O Mitter'
 125GIT_MERGE_VERBOSITY=5
 126GIT_MERGE_AUTOEDIT=no
 127export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
 128export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
 129export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
 130export EDITOR
 131
 132# Tests using GIT_TRACE typically don't want <timestamp> <file>:<line> output
 133GIT_TRACE_BARE=1
 134export GIT_TRACE_BARE
 135
 136if test -n "${TEST_GIT_INDEX_VERSION:+isset}"
 137then
 138        GIT_INDEX_VERSION="$TEST_GIT_INDEX_VERSION"
 139        export GIT_INDEX_VERSION
 140fi
 141
 142# Add libc MALLOC and MALLOC_PERTURB test
 143# only if we are not executing the test with valgrind
 144if expr " $GIT_TEST_OPTS " : ".* --valgrind " >/dev/null ||
 145   test -n "$TEST_NO_MALLOC_CHECK"
 146then
 147        setup_malloc_check () {
 148                : nothing
 149        }
 150        teardown_malloc_check () {
 151                : nothing
 152        }
 153else
 154        setup_malloc_check () {
 155                MALLOC_CHECK_=3 MALLOC_PERTURB_=165
 156                export MALLOC_CHECK_ MALLOC_PERTURB_
 157        }
 158        teardown_malloc_check () {
 159                unset MALLOC_CHECK_ MALLOC_PERTURB_
 160        }
 161fi
 162
 163# Protect ourselves from common misconfiguration to export
 164# CDPATH into the environment
 165unset CDPATH
 166
 167unset GREP_OPTIONS
 168unset UNZIP
 169
 170case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
 1711|2|true)
 172        GIT_TRACE=4
 173        ;;
 174esac
 175
 176# Convenience
 177#
 178# A regexp to match 5, 35 and 40 hexdigits
 179_x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
 180_x35="$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
 181_x40="$_x35$_x05"
 182
 183# Zero SHA-1
 184_z40=0000000000000000000000000000000000000000
 185
 186EMPTY_TREE=4b825dc642cb6eb9a060e54bf8d69288fbee4904
 187EMPTY_BLOB=e69de29bb2d1d6434b8b29ae775ad8c2e48c5391
 188
 189# Line feed
 190LF='
 191'
 192
 193# UTF-8 ZERO WIDTH NON-JOINER, which HFS+ ignores
 194# when case-folding filenames
 195u200c=$(printf '\342\200\214')
 196
 197export _x05 _x35 _x40 _z40 LF u200c EMPTY_TREE EMPTY_BLOB
 198
 199# Each test should start with something like this, after copyright notices:
 200#
 201# test_description='Description of this test...
 202# This test checks if command xyzzy does the right thing...
 203# '
 204# . ./test-lib.sh
 205test "x$TERM" != "xdumb" && (
 206                test -t 1 &&
 207                tput bold >/dev/null 2>&1 &&
 208                tput setaf 1 >/dev/null 2>&1 &&
 209                tput sgr0 >/dev/null 2>&1
 210        ) &&
 211        color=t
 212
 213while test "$#" -ne 0
 214do
 215        case "$1" in
 216        -d|--d|--de|--deb|--debu|--debug)
 217                debug=t; shift ;;
 218        -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
 219                immediate=t; shift ;;
 220        -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
 221                GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
 222        -r)
 223                shift; test "$#" -ne 0 || {
 224                        echo 'error: -r requires an argument' >&2;
 225                        exit 1;
 226                }
 227                run_list=$1; shift ;;
 228        --run=*)
 229                run_list=${1#--*=}; shift ;;
 230        -h|--h|--he|--hel|--help)
 231                help=t; shift ;;
 232        -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
 233                verbose=t; shift ;;
 234        --verbose-only=*)
 235                verbose_only=${1#--*=}
 236                shift ;;
 237        -q|--q|--qu|--qui|--quie|--quiet)
 238                # Ignore --quiet under a TAP::Harness. Saying how many tests
 239                # passed without the ok/not ok details is always an error.
 240                test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
 241        --with-dashes)
 242                with_dashes=t; shift ;;
 243        --no-color)
 244                color=; shift ;;
 245        --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
 246                valgrind=memcheck
 247                shift ;;
 248        --valgrind=*)
 249                valgrind=${1#--*=}
 250                shift ;;
 251        --valgrind-only=*)
 252                valgrind_only=${1#--*=}
 253                shift ;;
 254        --tee)
 255                shift ;; # was handled already
 256        --root=*)
 257                root=${1#--*=}
 258                shift ;;
 259        --chain-lint)
 260                GIT_TEST_CHAIN_LINT=1
 261                shift ;;
 262        --no-chain-lint)
 263                GIT_TEST_CHAIN_LINT=0
 264                shift ;;
 265        -x)
 266                trace=t
 267                verbose=t
 268                shift ;;
 269        --verbose-log)
 270                verbose_log=t
 271                shift ;;
 272        *)
 273                echo "error: unknown test option '$1'" >&2; exit 1 ;;
 274        esac
 275done
 276
 277if test -n "$valgrind_only"
 278then
 279        test -z "$valgrind" && valgrind=memcheck
 280        test -z "$verbose" && verbose_only="$valgrind_only"
 281elif test -n "$valgrind"
 282then
 283        test -z "$verbose_log" && verbose=t
 284fi
 285
 286if test -n "$color"
 287then
 288        # Save the color control sequences now rather than run tput
 289        # each time say_color() is called.  This is done for two
 290        # reasons:
 291        #   * TERM will be changed to dumb
 292        #   * HOME will be changed to a temporary directory and tput
 293        #     might need to read ~/.terminfo from the original HOME
 294        #     directory to get the control sequences
 295        # Note:  This approach assumes the control sequences don't end
 296        # in a newline for any terminal of interest (command
 297        # substitutions strip trailing newlines).  Given that most
 298        # (all?) terminals in common use are related to ECMA-48, this
 299        # shouldn't be a problem.
 300        say_color_error=$(tput bold; tput setaf 1) # bold red
 301        say_color_skip=$(tput setaf 4) # blue
 302        say_color_warn=$(tput setaf 3) # brown/yellow
 303        say_color_pass=$(tput setaf 2) # green
 304        say_color_info=$(tput setaf 6) # cyan
 305        say_color_reset=$(tput sgr0)
 306        say_color_="" # no formatting for normal text
 307        say_color () {
 308                test -z "$1" && test -n "$quiet" && return
 309                eval "say_color_color=\$say_color_$1"
 310                shift
 311                printf "%s\\n" "$say_color_color$*$say_color_reset"
 312        }
 313else
 314        say_color() {
 315                test -z "$1" && test -n "$quiet" && return
 316                shift
 317                printf "%s\n" "$*"
 318        }
 319fi
 320
 321TERM=dumb
 322export TERM
 323
 324error () {
 325        say_color error "error: $*"
 326        GIT_EXIT_OK=t
 327        exit 1
 328}
 329
 330say () {
 331        say_color info "$*"
 332}
 333
 334if test -n "$HARNESS_ACTIVE"
 335then
 336        if test "$verbose" = t || test -n "$verbose_only"
 337        then
 338                printf 'Bail out! %s\n' \
 339                 'verbose mode forbidden under TAP harness; try --verbose-log'
 340                exit 1
 341        fi
 342fi
 343
 344test "${test_description}" != "" ||
 345error "Test script did not set test_description."
 346
 347if test "$help" = "t"
 348then
 349        printf '%s\n' "$test_description"
 350        exit 0
 351fi
 352
 353exec 5>&1
 354exec 6<&0
 355exec 7>&2
 356if test "$verbose_log" = "t"
 357then
 358        exec 3>>"$GIT_TEST_TEE_OUTPUT_FILE" 4>&3
 359elif test "$verbose" = "t"
 360then
 361        exec 4>&2 3>&1
 362else
 363        exec 4>/dev/null 3>/dev/null
 364fi
 365
 366# Send any "-x" output directly to stderr to avoid polluting tests
 367# which capture stderr. We can do this unconditionally since it
 368# has no effect if tracing isn't turned on.
 369#
 370# Note that this sets up the trace fd as soon as we assign the variable, so it
 371# must come after the creation of descriptor 4 above. Likewise, we must never
 372# unset this, as it has the side effect of closing descriptor 4, which we
 373# use to show verbose tests to the user.
 374#
 375# Note also that we don't need or want to export it. The tracing is local to
 376# this shell, and we would not want to influence any shells we exec.
 377BASH_XTRACEFD=4
 378
 379test_failure=0
 380test_count=0
 381test_fixed=0
 382test_broken=0
 383test_success=0
 384
 385test_external_has_tap=0
 386
 387die () {
 388        code=$?
 389        if test -n "$GIT_EXIT_OK"
 390        then
 391                exit $code
 392        else
 393                echo >&5 "FATAL: Unexpected exit with code $code"
 394                exit 1
 395        fi
 396}
 397
 398GIT_EXIT_OK=
 399trap 'die' EXIT
 400trap 'exit $?' INT
 401
 402# The user-facing functions are loaded from a separate file so that
 403# test_perf subshells can have them too
 404. "$TEST_DIRECTORY/test-lib-functions.sh"
 405
 406# You are not expected to call test_ok_ and test_failure_ directly, use
 407# the test_expect_* functions instead.
 408
 409test_ok_ () {
 410        test_success=$(($test_success + 1))
 411        say_color "" "ok $test_count - $@"
 412}
 413
 414test_failure_ () {
 415        test_failure=$(($test_failure + 1))
 416        say_color error "not ok $test_count - $1"
 417        shift
 418        printf '%s\n' "$*" | sed -e 's/^/#      /'
 419        test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
 420}
 421
 422test_known_broken_ok_ () {
 423        test_fixed=$(($test_fixed+1))
 424        say_color error "ok $test_count - $@ # TODO known breakage vanished"
 425}
 426
 427test_known_broken_failure_ () {
 428        test_broken=$(($test_broken+1))
 429        say_color warn "not ok $test_count - $@ # TODO known breakage"
 430}
 431
 432test_debug () {
 433        test "$debug" = "" || eval "$1"
 434}
 435
 436match_pattern_list () {
 437        arg="$1"
 438        shift
 439        test -z "$*" && return 1
 440        for pattern_
 441        do
 442                case "$arg" in
 443                $pattern_)
 444                        return 0
 445                esac
 446        done
 447        return 1
 448}
 449
 450match_test_selector_list () {
 451        title="$1"
 452        shift
 453        arg="$1"
 454        shift
 455        test -z "$1" && return 0
 456
 457        # Both commas and whitespace are accepted as separators.
 458        OLDIFS=$IFS
 459        IFS='   ,'
 460        set -- $1
 461        IFS=$OLDIFS
 462
 463        # If the first selector is negative we include by default.
 464        include=
 465        case "$1" in
 466                !*) include=t ;;
 467        esac
 468
 469        for selector
 470        do
 471                orig_selector=$selector
 472
 473                positive=t
 474                case "$selector" in
 475                        !*)
 476                                positive=
 477                                selector=${selector##?}
 478                                ;;
 479                esac
 480
 481                test -z "$selector" && continue
 482
 483                case "$selector" in
 484                        *-*)
 485                                if expr "z${selector%%-*}" : "z[0-9]*[^0-9]" >/dev/null
 486                                then
 487                                        echo "error: $title: invalid non-numeric in range" \
 488                                                "start: '$orig_selector'" >&2
 489                                        exit 1
 490                                fi
 491                                if expr "z${selector#*-}" : "z[0-9]*[^0-9]" >/dev/null
 492                                then
 493                                        echo "error: $title: invalid non-numeric in range" \
 494                                                "end: '$orig_selector'" >&2
 495                                        exit 1
 496                                fi
 497                                ;;
 498                        *)
 499                                if expr "z$selector" : "z[0-9]*[^0-9]" >/dev/null
 500                                then
 501                                        echo "error: $title: invalid non-numeric in test" \
 502                                                "selector: '$orig_selector'" >&2
 503                                        exit 1
 504                                fi
 505                esac
 506
 507                # Short cut for "obvious" cases
 508                test -z "$include" && test -z "$positive" && continue
 509                test -n "$include" && test -n "$positive" && continue
 510
 511                case "$selector" in
 512                        -*)
 513                                if test $arg -le ${selector#-}
 514                                then
 515                                        include=$positive
 516                                fi
 517                                ;;
 518                        *-)
 519                                if test $arg -ge ${selector%-}
 520                                then
 521                                        include=$positive
 522                                fi
 523                                ;;
 524                        *-*)
 525                                if test ${selector%%-*} -le $arg \
 526                                        && test $arg -le ${selector#*-}
 527                                then
 528                                        include=$positive
 529                                fi
 530                                ;;
 531                        *)
 532                                if test $arg -eq $selector
 533                                then
 534                                        include=$positive
 535                                fi
 536                                ;;
 537                esac
 538        done
 539
 540        test -n "$include"
 541}
 542
 543maybe_teardown_verbose () {
 544        test -z "$verbose_only" && return
 545        exec 4>/dev/null 3>/dev/null
 546        verbose=
 547}
 548
 549last_verbose=t
 550maybe_setup_verbose () {
 551        test -z "$verbose_only" && return
 552        if match_pattern_list $test_count $verbose_only
 553        then
 554                exec 4>&2 3>&1
 555                # Emit a delimiting blank line when going from
 556                # non-verbose to verbose.  Within verbose mode the
 557                # delimiter is printed by test_expect_*.  The choice
 558                # of the initial $last_verbose is such that before
 559                # test 1, we do not print it.
 560                test -z "$last_verbose" && echo >&3 ""
 561                verbose=t
 562        else
 563                exec 4>/dev/null 3>/dev/null
 564                verbose=
 565        fi
 566        last_verbose=$verbose
 567}
 568
 569maybe_teardown_valgrind () {
 570        test -z "$GIT_VALGRIND" && return
 571        GIT_VALGRIND_ENABLED=
 572}
 573
 574maybe_setup_valgrind () {
 575        test -z "$GIT_VALGRIND" && return
 576        if test -z "$valgrind_only"
 577        then
 578                GIT_VALGRIND_ENABLED=t
 579                return
 580        fi
 581        GIT_VALGRIND_ENABLED=
 582        if match_pattern_list $test_count $valgrind_only
 583        then
 584                GIT_VALGRIND_ENABLED=t
 585        fi
 586}
 587
 588want_trace () {
 589        test "$trace" = t && test "$verbose" = t
 590}
 591
 592# This is a separate function because some tests use
 593# "return" to end a test_expect_success block early
 594# (and we want to make sure we run any cleanup like
 595# "set +x").
 596test_eval_inner_ () {
 597        # Do not add anything extra (including LF) after '$*'
 598        eval "
 599                want_trace && set -x
 600                $*"
 601}
 602
 603test_eval_ () {
 604        # If "-x" tracing is in effect, then we want to avoid polluting stderr
 605        # with non-test commands. But once in "set -x" mode, we cannot prevent
 606        # the shell from printing the "set +x" to turn it off (nor the saving
 607        # of $? before that). But we can make sure that the output goes to
 608        # /dev/null.
 609        #
 610        # There are a few subtleties here:
 611        #
 612        #   - we have to redirect descriptor 4 in addition to 2, to cover
 613        #     BASH_XTRACEFD
 614        #
 615        #   - the actual eval has to come before the redirection block (since
 616        #     it needs to see descriptor 4 to set up its stderr)
 617        #
 618        #   - likewise, any error message we print must be outside the block to
 619        #     access descriptor 4
 620        #
 621        #   - checking $? has to come immediately after the eval, but it must
 622        #     be _inside_ the block to avoid polluting the "set -x" output
 623        #
 624
 625        test_eval_inner_ "$@" </dev/null >&3 2>&4
 626        {
 627                test_eval_ret_=$?
 628                if want_trace
 629                then
 630                        set +x
 631                fi
 632        } 2>/dev/null 4>&2
 633
 634        if test "$test_eval_ret_" != 0 && want_trace
 635        then
 636                say_color error >&4 "error: last command exited with \$?=$test_eval_ret_"
 637        fi
 638        return $test_eval_ret_
 639}
 640
 641test_run_ () {
 642        test_cleanup=:
 643        expecting_failure=$2
 644
 645        if test "${GIT_TEST_CHAIN_LINT:-1}" != 0; then
 646                # turn off tracing for this test-eval, as it simply creates
 647                # confusing noise in the "-x" output
 648                trace_tmp=$trace
 649                trace=
 650                # 117 is magic because it is unlikely to match the exit
 651                # code of other programs
 652                if test "OK-117" != "$(test_eval_ "(exit 117) && $1${LF}${LF}echo OK-\$?" 3>&1)"
 653                then
 654                        error "bug in the test script: broken &&-chain or run-away HERE-DOC: $1"
 655                fi
 656                trace=$trace_tmp
 657        fi
 658
 659        setup_malloc_check
 660        test_eval_ "$1"
 661        eval_ret=$?
 662        teardown_malloc_check
 663
 664        if test -z "$immediate" || test $eval_ret = 0 ||
 665           test -n "$expecting_failure" && test "$test_cleanup" != ":"
 666        then
 667                setup_malloc_check
 668                test_eval_ "$test_cleanup"
 669                teardown_malloc_check
 670        fi
 671        if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"
 672        then
 673                echo ""
 674        fi
 675        return "$eval_ret"
 676}
 677
 678test_start_ () {
 679        test_count=$(($test_count+1))
 680        maybe_setup_verbose
 681        maybe_setup_valgrind
 682}
 683
 684test_finish_ () {
 685        echo >&3 ""
 686        maybe_teardown_valgrind
 687        maybe_teardown_verbose
 688}
 689
 690test_skip () {
 691        to_skip=
 692        skipped_reason=
 693        if match_pattern_list $this_test.$test_count $GIT_SKIP_TESTS
 694        then
 695                to_skip=t
 696                skipped_reason="GIT_SKIP_TESTS"
 697        fi
 698        if test -z "$to_skip" && test -n "$test_prereq" &&
 699           ! test_have_prereq "$test_prereq"
 700        then
 701                to_skip=t
 702
 703                of_prereq=
 704                if test "$missing_prereq" != "$test_prereq"
 705                then
 706                        of_prereq=" of $test_prereq"
 707                fi
 708                skipped_reason="missing $missing_prereq${of_prereq}"
 709        fi
 710        if test -z "$to_skip" && test -n "$run_list" &&
 711                ! match_test_selector_list '--run' $test_count "$run_list"
 712        then
 713                to_skip=t
 714                skipped_reason="--run"
 715        fi
 716
 717        case "$to_skip" in
 718        t)
 719                say_color skip >&3 "skipping test: $@"
 720                say_color skip "ok $test_count # skip $1 ($skipped_reason)"
 721                : true
 722                ;;
 723        *)
 724                false
 725                ;;
 726        esac
 727}
 728
 729# stub; perf-lib overrides it
 730test_at_end_hook_ () {
 731        :
 732}
 733
 734test_done () {
 735        GIT_EXIT_OK=t
 736
 737        if test -z "$HARNESS_ACTIVE"
 738        then
 739                test_results_dir="$TEST_OUTPUT_DIRECTORY/test-results"
 740                mkdir -p "$test_results_dir"
 741                base=${0##*/}
 742                test_results_path="$test_results_dir/${base%.sh}.counts"
 743
 744                cat >"$test_results_path" <<-EOF
 745                total $test_count
 746                success $test_success
 747                fixed $test_fixed
 748                broken $test_broken
 749                failed $test_failure
 750
 751                EOF
 752        fi
 753
 754        if test "$test_fixed" != 0
 755        then
 756                say_color error "# $test_fixed known breakage(s) vanished; please update test(s)"
 757        fi
 758        if test "$test_broken" != 0
 759        then
 760                say_color warn "# still have $test_broken known breakage(s)"
 761        fi
 762        if test "$test_broken" != 0 || test "$test_fixed" != 0
 763        then
 764                test_remaining=$(( $test_count - $test_broken - $test_fixed ))
 765                msg="remaining $test_remaining test(s)"
 766        else
 767                test_remaining=$test_count
 768                msg="$test_count test(s)"
 769        fi
 770        case "$test_failure" in
 771        0)
 772                if test $test_external_has_tap -eq 0
 773                then
 774                        if test $test_remaining -gt 0
 775                        then
 776                                say_color pass "# passed all $msg"
 777                        fi
 778
 779                        # Maybe print SKIP message
 780                        test -z "$skip_all" || skip_all="# SKIP $skip_all"
 781                        case "$test_count" in
 782                        0)
 783                                say "1..$test_count${skip_all:+ $skip_all}"
 784                                ;;
 785                        *)
 786                                test -z "$skip_all" ||
 787                                say_color warn "$skip_all"
 788                                say "1..$test_count"
 789                                ;;
 790                        esac
 791                fi
 792
 793                if test -z "$debug"
 794                then
 795                        test -d "$TRASH_DIRECTORY" ||
 796                        error "Tests passed but trash directory already removed before test cleanup; aborting"
 797
 798                        cd "$TRASH_DIRECTORY/.." &&
 799                        rm -fr "$TRASH_DIRECTORY" ||
 800                        error "Tests passed but test cleanup failed; aborting"
 801                fi
 802                test_at_end_hook_
 803
 804                exit 0 ;;
 805
 806        *)
 807                if test $test_external_has_tap -eq 0
 808                then
 809                        say_color error "# failed $test_failure among $msg"
 810                        say "1..$test_count"
 811                fi
 812
 813                exit 1 ;;
 814
 815        esac
 816}
 817
 818if test -n "$valgrind"
 819then
 820        make_symlink () {
 821                test -h "$2" &&
 822                test "$1" = "$(readlink "$2")" || {
 823                        # be super paranoid
 824                        if mkdir "$2".lock
 825                        then
 826                                rm -f "$2" &&
 827                                ln -s "$1" "$2" &&
 828                                rm -r "$2".lock
 829                        else
 830                                while test -d "$2".lock
 831                                do
 832                                        say "Waiting for lock on $2."
 833                                        sleep 1
 834                                done
 835                        fi
 836                }
 837        }
 838
 839        make_valgrind_symlink () {
 840                # handle only executables, unless they are shell libraries that
 841                # need to be in the exec-path.
 842                test -x "$1" ||
 843                test "# " = "$(head -c 2 <"$1")" ||
 844                return;
 845
 846                base=$(basename "$1")
 847                case "$base" in
 848                test-*)
 849                        symlink_target="$GIT_BUILD_DIR/t/helper/$base"
 850                        ;;
 851                *)
 852                        symlink_target="$GIT_BUILD_DIR/$base"
 853                        ;;
 854                esac
 855                # do not override scripts
 856                if test -x "$symlink_target" &&
 857                    test ! -d "$symlink_target" &&
 858                    test "#!" != "$(head -c 2 < "$symlink_target")"
 859                then
 860                        symlink_target=../valgrind.sh
 861                fi
 862                case "$base" in
 863                *.sh|*.perl)
 864                        symlink_target=../unprocessed-script
 865                esac
 866                # create the link, or replace it if it is out of date
 867                make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
 868        }
 869
 870        # override all git executables in TEST_DIRECTORY/..
 871        GIT_VALGRIND=$TEST_DIRECTORY/valgrind
 872        mkdir -p "$GIT_VALGRIND"/bin
 873        for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/t/helper/test-*
 874        do
 875                make_valgrind_symlink $file
 876        done
 877        # special-case the mergetools loadables
 878        make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
 879        OLDIFS=$IFS
 880        IFS=:
 881        for path in $PATH
 882        do
 883                ls "$path"/git-* 2> /dev/null |
 884                while read file
 885                do
 886                        make_valgrind_symlink "$file"
 887                done
 888        done
 889        IFS=$OLDIFS
 890        PATH=$GIT_VALGRIND/bin:$PATH
 891        GIT_EXEC_PATH=$GIT_VALGRIND/bin
 892        export GIT_VALGRIND
 893        GIT_VALGRIND_MODE="$valgrind"
 894        export GIT_VALGRIND_MODE
 895        GIT_VALGRIND_ENABLED=t
 896        test -n "$valgrind_only" && GIT_VALGRIND_ENABLED=
 897        export GIT_VALGRIND_ENABLED
 898elif test -n "$GIT_TEST_INSTALLED"
 899then
 900        GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path)  ||
 901        error "Cannot run git from $GIT_TEST_INSTALLED."
 902        PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
 903        GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
 904else # normal case, use ../bin-wrappers only unless $with_dashes:
 905        git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
 906        if ! test -x "$git_bin_dir/git"
 907        then
 908                if test -z "$with_dashes"
 909                then
 910                        say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
 911                fi
 912                with_dashes=t
 913        fi
 914        PATH="$git_bin_dir:$PATH"
 915        GIT_EXEC_PATH=$GIT_BUILD_DIR
 916        if test -n "$with_dashes"
 917        then
 918                PATH="$GIT_BUILD_DIR:$PATH"
 919        fi
 920fi
 921GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
 922GIT_CONFIG_NOSYSTEM=1
 923GIT_ATTR_NOSYSTEM=1
 924export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
 925
 926if test -z "$GIT_TEST_CMP"
 927then
 928        if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
 929        then
 930                GIT_TEST_CMP="$DIFF -c"
 931        else
 932                GIT_TEST_CMP="$DIFF -u"
 933        fi
 934fi
 935
 936GITPERLLIB="$GIT_BUILD_DIR"/perl/blib/lib:"$GIT_BUILD_DIR"/perl/blib/arch/auto/Git
 937export GITPERLLIB
 938test -d "$GIT_BUILD_DIR"/templates/blt || {
 939        error "You haven't built things yet, have you?"
 940}
 941
 942if ! test -x "$GIT_BUILD_DIR"/t/helper/test-chmtime
 943then
 944        echo >&2 'You need to build test-chmtime:'
 945        echo >&2 'Run "make t/helper/test-chmtime" in the source (toplevel) directory'
 946        exit 1
 947fi
 948
 949# Test repository
 950TRASH_DIRECTORY="trash directory.$(basename "$0" .sh)"
 951test -n "$root" && TRASH_DIRECTORY="$root/$TRASH_DIRECTORY"
 952case "$TRASH_DIRECTORY" in
 953/*) ;; # absolute path is good
 954 *) TRASH_DIRECTORY="$TEST_OUTPUT_DIRECTORY/$TRASH_DIRECTORY" ;;
 955esac
 956rm -fr "$TRASH_DIRECTORY" || {
 957        GIT_EXIT_OK=t
 958        echo >&5 "FATAL: Cannot prepare test area"
 959        exit 1
 960}
 961
 962HOME="$TRASH_DIRECTORY"
 963GNUPGHOME="$HOME/gnupg-home-not-used"
 964export HOME GNUPGHOME
 965
 966if test -z "$TEST_NO_CREATE_REPO"
 967then
 968        test_create_repo "$TRASH_DIRECTORY"
 969else
 970        mkdir -p "$TRASH_DIRECTORY"
 971fi
 972# Use -P to resolve symlinks in our working directory so that the cwd
 973# in subprocesses like git equals our $PWD (for pathname comparisons).
 974cd -P "$TRASH_DIRECTORY" || exit 1
 975
 976this_test=${0##*/}
 977this_test=${this_test%%-*}
 978if match_pattern_list "$this_test" $GIT_SKIP_TESTS
 979then
 980        say_color info >&3 "skipping test $this_test altogether"
 981        skip_all="skip all tests in $this_test"
 982        test_done
 983fi
 984
 985# Provide an implementation of the 'yes' utility
 986yes () {
 987        if test $# = 0
 988        then
 989                y=y
 990        else
 991                y="$*"
 992        fi
 993
 994        i=0
 995        while test $i -lt 99
 996        do
 997                echo "$y"
 998                i=$(($i+1))
 999        done
1000}
1001
1002# Fix some commands on Windows
1003uname_s=$(uname -s)
1004case $uname_s in
1005*MINGW*)
1006        # Windows has its own (incompatible) sort and find
1007        sort () {
1008                /usr/bin/sort "$@"
1009        }
1010        find () {
1011                /usr/bin/find "$@"
1012        }
1013        # git sees Windows-style pwd
1014        pwd () {
1015                builtin pwd -W
1016        }
1017        # no POSIX permissions
1018        # backslashes in pathspec are converted to '/'
1019        # exec does not inherit the PID
1020        test_set_prereq MINGW
1021        test_set_prereq NATIVE_CRLF
1022        test_set_prereq SED_STRIPS_CR
1023        test_set_prereq GREP_STRIPS_CR
1024        GIT_TEST_CMP=mingw_test_cmp
1025        ;;
1026*CYGWIN*)
1027        test_set_prereq POSIXPERM
1028        test_set_prereq EXECKEEPSPID
1029        test_set_prereq CYGWIN
1030        test_set_prereq SED_STRIPS_CR
1031        test_set_prereq GREP_STRIPS_CR
1032        ;;
1033*)
1034        test_set_prereq POSIXPERM
1035        test_set_prereq BSLASHPSPEC
1036        test_set_prereq EXECKEEPSPID
1037        ;;
1038esac
1039
1040( COLUMNS=1 && test $COLUMNS = 1 ) && test_set_prereq COLUMNS_CAN_BE_1
1041test -z "$NO_PERL" && test_set_prereq PERL
1042test -z "$NO_PTHREADS" && test_set_prereq PTHREADS
1043test -z "$NO_PYTHON" && test_set_prereq PYTHON
1044test -n "$USE_LIBPCRE1$USE_LIBPCRE2" && test_set_prereq PCRE
1045test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
1046
1047# Can we rely on git's output in the C locale?
1048if test -n "$GETTEXT_POISON"
1049then
1050        GIT_GETTEXT_POISON=YesPlease
1051        export GIT_GETTEXT_POISON
1052        test_set_prereq GETTEXT_POISON
1053else
1054        test_set_prereq C_LOCALE_OUTPUT
1055fi
1056
1057# Use this instead of test_cmp to compare files that contain expected and
1058# actual output from git commands that can be translated.  When running
1059# under GETTEXT_POISON this pretends that the command produced expected
1060# results.
1061test_i18ncmp () {
1062        test -n "$GETTEXT_POISON" || test_cmp "$@"
1063}
1064
1065# Use this instead of "grep expected-string actual" to see if the
1066# output from a git command that can be translated either contains an
1067# expected string, or does not contain an unwanted one.  When running
1068# under GETTEXT_POISON this pretends that the command produced expected
1069# results.
1070test_i18ngrep () {
1071        if test -n "$GETTEXT_POISON"
1072        then
1073            : # pretend success
1074        elif test "x!" = "x$1"
1075        then
1076                shift
1077                ! grep "$@"
1078        else
1079                grep "$@"
1080        fi
1081}
1082
1083test_lazy_prereq PIPE '
1084        # test whether the filesystem supports FIFOs
1085        test_have_prereq !MINGW,!CYGWIN &&
1086        rm -f testfifo && mkfifo testfifo
1087'
1088
1089test_lazy_prereq SYMLINKS '
1090        # test whether the filesystem supports symbolic links
1091        ln -s x y && test -h y
1092'
1093
1094test_lazy_prereq FILEMODE '
1095        test "$(git config --bool core.filemode)" = true
1096'
1097
1098test_lazy_prereq CASE_INSENSITIVE_FS '
1099        echo good >CamelCase &&
1100        echo bad >camelcase &&
1101        test "$(cat CamelCase)" != good
1102'
1103
1104test_lazy_prereq UTF8_NFD_TO_NFC '
1105        # check whether FS converts nfd unicode to nfc
1106        auml=$(printf "\303\244")
1107        aumlcdiar=$(printf "\141\314\210")
1108        >"$auml" &&
1109        case "$(echo *)" in
1110        "$aumlcdiar")
1111                true ;;
1112        *)
1113                false ;;
1114        esac
1115'
1116
1117test_lazy_prereq AUTOIDENT '
1118        sane_unset GIT_AUTHOR_NAME &&
1119        sane_unset GIT_AUTHOR_EMAIL &&
1120        git var GIT_AUTHOR_IDENT
1121'
1122
1123test_lazy_prereq EXPENSIVE '
1124        test -n "$GIT_TEST_LONG"
1125'
1126
1127test_lazy_prereq USR_BIN_TIME '
1128        test -x /usr/bin/time
1129'
1130
1131test_lazy_prereq NOT_ROOT '
1132        uid=$(id -u) &&
1133        test "$uid" != 0
1134'
1135
1136test_lazy_prereq JGIT '
1137        type jgit
1138'
1139
1140# SANITY is about "can you correctly predict what the filesystem would
1141# do by only looking at the permission bits of the files and
1142# directories?"  A typical example of !SANITY is running the test
1143# suite as root, where a test may expect "chmod -r file && cat file"
1144# to fail because file is supposed to be unreadable after a successful
1145# chmod.  In an environment (i.e. combination of what filesystem is
1146# being used and who is running the tests) that lacks SANITY, you may
1147# be able to delete or create a file when the containing directory
1148# doesn't have write permissions, or access a file even if the
1149# containing directory doesn't have read or execute permissions.
1150
1151test_lazy_prereq SANITY '
1152        mkdir SANETESTD.1 SANETESTD.2 &&
1153
1154        chmod +w SANETESTD.1 SANETESTD.2 &&
1155        >SANETESTD.1/x 2>SANETESTD.2/x &&
1156        chmod -w SANETESTD.1 &&
1157        chmod -r SANETESTD.1/x &&
1158        chmod -rx SANETESTD.2 ||
1159        error "bug in test sript: cannot prepare SANETESTD"
1160
1161        ! test -r SANETESTD.1/x &&
1162        ! rm SANETESTD.1/x && ! test -f SANETESTD.2/x
1163        status=$?
1164
1165        chmod +rwx SANETESTD.1 SANETESTD.2 &&
1166        rm -rf SANETESTD.1 SANETESTD.2 ||
1167        error "bug in test sript: cannot clean SANETESTD"
1168        return $status
1169'
1170
1171test FreeBSD != $uname_s || GIT_UNZIP=${GIT_UNZIP:-/usr/local/bin/unzip}
1172GIT_UNZIP=${GIT_UNZIP:-unzip}
1173test_lazy_prereq UNZIP '
1174        "$GIT_UNZIP" -v
1175        test $? -ne 127
1176'
1177
1178run_with_limited_cmdline () {
1179        (ulimit -s 128 && "$@")
1180}
1181
1182test_lazy_prereq CMDLINE_LIMIT '
1183        test_have_prereq !MINGW,!CYGWIN &&
1184        run_with_limited_cmdline true
1185'
1186
1187run_with_limited_stack () {
1188        (ulimit -s 128 && "$@")
1189}
1190
1191test_lazy_prereq ULIMIT_STACK_SIZE '
1192        test_have_prereq !MINGW,!CYGWIN &&
1193        run_with_limited_stack true
1194'
1195
1196build_option () {
1197        git version --build-options |
1198        sed -ne "s/^$1: //p"
1199}
1200
1201test_lazy_prereq LONG_IS_64BIT '
1202        test 8 -le "$(build_option sizeof-long)"
1203'
1204
1205test_lazy_prereq TIME_IS_64BIT 'test-date is64bit'
1206test_lazy_prereq TIME_T_IS_64BIT 'test-date time_t-is64bit'